﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SuperMap.Desktop.Samples
{
    public partial class BindGroupManager : Form
    {
        IBindGroup m_bindGroup;
        public BindGroupManager()
        {
            InitializeComponent();
            IBindGroupManager bindGroupManager = Application.ActiveApplication.MainForm.BindGroupManager;
            m_bindGroup = bindGroupManager[0];
            for (Int32 i = 0; i < Application.ActiveApplication.MainForm.FormManager.Count; i++)
            {

                Form form = Application.ActiveApplication.MainForm.FormManager[i] as Form;
                if (form is IFormMap || form is IFormScene || form is IFormTabular || form is IFormSuperTabular)
                {
                    ListViewItem item = AddItem(form);
                }
            }
            InitializeBindGroup();
        }

        private void InitializeBindGroup()
        {
            try
            {
                if (m_bindGroup != null)
                {
                    foreach (ListViewItem item in m_listViewForms.Items)
                    {
                        item.Checked = m_bindGroup.Contains(item.Tag as IForm);
                    }
                }
                else
                {
                    foreach (ListViewItem item in m_listViewForms.Items)
                    {
                        item.Checked = false;
                    }
                }
            }
            catch (Exception ex)
            {
                Application.ActiveApplication.Output.Output(ex.StackTrace, InfoType.Exception);
            }
        }

        private ListViewItem AddItem(Form form)
        {
            ListViewItem item = new ListViewItem();
            item.Tag = form;
            item.Text = form.Text;
            m_listViewForms.Items.Add(item);
            return item;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                List<IForm> formList = new List<IForm>();
                foreach (ListViewItem item in m_listViewForms.Items)
                {
                    if (item.Checked)
                    {
                        IForm form = item.Tag as IForm;
                        if (form != null)
                        {
                            formList.Add(form);
                        }
                    }
                }
                if (formList.Count <= 1)
                {
                    (Application.ActiveApplication.MainForm as FormBase).BindGroupManager.Clear();
                }
                else
                {
                    Application.ActiveApplication.MainForm.FormManager.BindForms(formList.ToArray(), true);
                }
                this.DialogResult = DialogResult.OK;
            }
            catch (Exception ex)
            {
                Application.ActiveApplication.Output.Output(ex.StackTrace, InfoType.Exception);
            }
        }
    }
}
